#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

typedef enum { moto, macchina , caravan, camion } Articolo;

typedef enum { compra, vende } Tipo;

typedef struct { char nome[100];
                 Articolo articolo;
                 float prezzo;
                 Tipo tipo; } Annuncio;
                 
typedef struct { Annuncio annunci[100];
                 int n; } Annunci;               

void inizializza(Annunci *a);
void leggiAnnuncio(Annuncio *a);
void aggiungiAnnuncio(Annunci *a);
void stampaAnnuncio(Annuncio a);
void stampaAnnunci(Annunci a);
void modifica(Annunci *a, char nome[], int tipo);
void modificaView(Annunci *a);
void menu() ;
void stampaView(Annunci a);
void mediaPrezzi(Annunci a);
void cerca(Annunci a);
void cancella(Annunci *a);

int main(int argc, char *argv[])
{
  Annunci a;
  int scelta;
  inizializza(&a);
  do { 
       menu();
       do {
           scanf("%d",&scelta); }
       while((scelta<1)||(scelta>8));
       switch(scelta) {
                 case 1: {
                      aggiungiAnnuncio(&a);
                      break; }
                 case 2: {
                      stampaAnnunci(a);
                      break; }
                 case 3: {
                      stampaView(a);
                      break; }
                 case 4: {
                      modificaView(&a);
                      break; }
                 case 5: {
                      mediaPrezzi(a);
                      break; }
                 case 6: {
                      cerca(a);
                      break; }
                 case 7: {
                      cancella(&a);
                      break; }
                 }}
  while(scelta!=8);
  system("PAUSE");	
  return 0;
}

void stampaView(Annunci a) {
     int i;
     printf("Introduci il numero dell'annuncio da visualizzare\n");
     do {
         scanf("%d",&i); }
     while((i<0)||(i>a.n));
     stampaAnnuncio(a.annunci[i-1]);          
}

void mediaPrezzi(Annunci a) {
     int s1=0,s2=0,s3=0,s4=0,i,i1=0,i2=0,i3=0,i4=0;
     float m1,m2,m3,m4;
     for(i=0;i<a.n;i++) {
                        switch(a.annunci[i].tipo) {
                                                  case 0: { s1+=a.annunci[i].prezzo;
                                                            i1++;
                                                            break; } 
                                                  case 1: { s2+=a.annunci[i].prezzo;
                                                            i2++;
                                                            break; }
                                                  case 2: { s3+=a.annunci[i].prezzo;
                                                            i3++;
                                                            break; }  
                                                  case 3: { s4+=a.annunci[i].prezzo;
                                                            i4++;
                                                            break; }
                        }
     }
     if(i1==0) 
               printf("Non ci sono articoli di tipo moto\n");
     else {
          m1=((float)s1)/i1;
          printf("La media dei prezi delle moto : %f \n",m1); }
     if(i2==0) 
               printf("Non ci sono articoli di tipo macchina\n");
     else {
          m2=((float)s2)/i2;
          printf("La media dei prezi delle macchine : %f \n",m2); }
     if(i3==0) 
               printf("Non ci sono articoli di tipo caravan\n");
     else {
          m3=((float)s3)/i3;
          printf("La media dei prezi dei caravan : %f \n",m3); }
     if(i4==0) 
               printf("Non ci sono articoli di tipo camion\n");
     else {
          m4=((float)s4)/i4;
          printf("La media dei prezi dei camion : %f \n",m4); }
}

void cerca(Annunci a) {
     int articolo,tipo,i;
     float pmax,pmin;
     printf("Introduci 0 per moto, 1 per macchina, 2 per caravan, 3 per camion\n");
     do {
         scanf("%d",&articolo); }
     while((articolo<0)||(articolo>3));
      printf("Introduci 0 per compra o 1 per vende\n");
     do {
         scanf("%d",&tipo); }
     while((tipo<0)||(tipo>1));
     printf("Introduci il prezzo minimo in euro\n");
     scanf("%f",&pmin);
     printf("Introduci il prezzo massimo in euro\n");
     scanf("%f",&pmax);
     for(i=0;i<a.n;i++) {
                        if((a.annunci[i].tipo!=tipo)&&((a.annunci[i].prezzo>pmin)&&(a.annunci[i].prezzo<pmax)))
                          stampaAnnuncio(a.annunci[i]);
     }
}

void cancella(Annunci *a) {
     int i,i1,i2;
     char sino;
     printf("Introduci il numero del primo articolo da cancellare\n");
     do {
         scanf("%d",&i1); }
     while((i1<1)||(i1>a->n));
     printf("Introduci il numero del secondo articolo da cancellare\n");
     do {
         scanf("%d",&i2); }
     while((i2<1)||(i2>a->n));
     stampaAnnuncio(a->annunci[i1-1]);
     stampaAnnuncio(a->annunci[i2-1]);
     printf("Sei sicuro di voler modificare il prezzo dell'articolo? s/n \n");
     do {
        scanf("%c",&sino); }
     while((sino!='s')&&(sino!='n'));
        if (sino=='s') {
                          a->annunci[i1-1]=a->annunci[a->n-1];
                          a->n--;
                          a->annunci[i1-1]=a->annunci[a->n-1];
                          a->n--; }
}

void inizializza(Annunci *a) {
     // inizializza gli annunci a 0
     a->n=0;
}

void menu() {
    printf("\nIntroduci 1 per aggiungere un annuncio\n");
    printf("Introduci 2 per visualizzare tutti gli annunci\n");
    printf("Introduci 3 per visualizzare un dato annuncio\n"); 
    printf("Introduci 4 per modificare prezzo di un annuncio\n");
    printf("Introduci 5 per visualizzare il numero e il prezzo medio di ogni articolo\n");
    printf("Introduci 6 per cercare un annuncio\n");
    printf("Introduci 7 per cancellare 2 annunci che si soddisfano a vicenda\n");
    printf("Introduci 8 per uscire\n");
}

void leggiAnnuncio(Annuncio *a) {
     // legge un annuncio da tastiera     
     int i;
     fflush(stdin);
     printf("\nIntroduci il nome e cognome\n");
     gets(a->nome);
     printf("Introduci 0 per moto, 1 per macchina, 2 per caravan, 3 per camion\n");
     do {
         scanf("%d",&i); }
     while((i<0)||(i>3));
     a->articolo=i;
     printf("Introduci il prezzo in euro\n");
     scanf("%f",&a->prezzo);
     fflush(stdin);
     printf("Introduci 0 per compra o 1 per vende\n");
     do {
         scanf("%d",&i); }
     while((i<0)||(i>1));
     a->tipo=i;
}

void aggiungiAnnuncio(Annunci *a) {
     // aggiunge un annuncio all'array di annunci tramite la funzione leggiAnnuncio
     leggiAnnuncio(&(a->annunci[a->n]));
     a->n++;
}

void stampaAnnuncio(Annuncio a) {
     int i;
     printf("\nNome: %s\n",a.nome);
     printf("Articolo: ");
     switch(a.articolo) {
                        case 0: { printf("moto\n");
                                  break; }
                        case 1: { printf("macchina\n");
                                  break; }
                        case 2: { printf("caravan\n");
                                  break; }
                        case 3: { printf("camion\n");
                                  break; }
                        }
     printf("Prezzo: %f euro\n",a.prezzo);
     printf("Tipo: ");
     switch(a.tipo) {
                        case 0: { printf("compra\n");
                                  break; }
                        case 1: { printf("vende\n");
                                  break; }
                        }
}

void stampaAnnunci(Annunci a) {
     int i;
     for(i=0;i<a.n;i++) {
                        printf("\narticolo n %d",i+1);
                        stampaAnnuncio(a.annunci[i]);
     }
}

void modifica(Annunci *a, char nome[], int tipo) {
     int i=0;
     char sino;
     for(i=0;i<a->n;i++) {
         if((strcmp(a->annunci[i].nome,nome)==0)&&(a->annunci[i].tipo==tipo)) {
            stampaAnnuncio(a->annunci[i]);
            printf("Sei sicuro di voler modificare il prezzo dell'articolo? s/n \n");
            do {
                scanf("%c",&sino); }
            while((sino!='s')&&(sino!='n'));
            if (sino=='s') {
                           printf("Introduci il nuovo prezzo in euro\n");
                           scanf("%f",&a->annunci[i].prezzo); }
            }   
     }
}

void modificaView(Annunci *a) {
     char nome[100];
     int i;
     fflush(stdin);
     printf("\nIntroduci il nome e cognome\n");
     gets(nome);
     printf("Introduci 0 per compra o 1 per vende\n");
     do {
         scanf("%d",&i); }
     while((i<0)||(i>1));
     modifica(a,nome,i);
}
